﻿Imports Telerik.WinControls.UI

Public Class RadForm1

    Private Sub RadForm1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'NwindDataSet.Orders' table. You can move, or remove it, as needed.
        Me.OrdersTableAdapter.Fill(Me.NwindDataSet.Orders)

        Dim col As GridViewMultiComboBoxColumn = New GridViewMultiComboBoxColumn("Orders")
        col.DataSource = Me.OrdersBindingSource
        col.DisplayMember = "OrderID"
        col.ValueMember = "OrderID"
        Me.RadGridView1.Columns.Add(col)

        Me.RadGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill

        AddHandler Me.RadGridView1.CellEditorInitialized, AddressOf RadGridView_CellEditorInitialized
    End Sub

    Private Sub RadGridView_CellEditorInitialized(sender As Object, e As GridViewCellEventArgs)
        Dim mccb As RadMultiColumnComboBoxElement = TryCast(e.ActiveEditor, RadMultiColumnComboBoxElement)

        If mccb IsNot Nothing Then
            mccb.AutoSizeDropDownToBestFit = True
            mccb.EditorControl.ShowFilteringRow = True
            mccb.EditorControl.EnableFiltering = True
            mccb.EditorControl.FilterDescriptors.Clear()
            mccb.EditorControl.CurrentRow = mccb.EditorControl.MasterView.TableFilteringRow
            RemoveHandler mccb.EditorControl.ViewCellFormatting, AddressOf EditorControl_ViewCellFormatting
            AddHandler mccb.EditorControl.ViewCellFormatting, AddressOf EditorControl_ViewCellFormatting

            RemoveHandler mccb.PopupClosing, AddressOf mccb_PopupClosing
            RemoveHandler mccb.PopupClosing, AddressOf mccb_PopupClosing
        End If
    End Sub

    Private Sub mccb_PopupClosing(ByVal sender As Object, ByVal args As RadPopupClosingEventArgs)
        Dim mccb As RadMultiColumnComboBoxElement = TryCast(sender, RadMultiColumnComboBoxElement)
        Dim shouldCancel As Boolean = False
        If mccb.EditorControl.CurrentRow Is mccb.EditorControl.MasterView.TableFilteringRow Then
            shouldCancel = True
        End If
        args.Cancel = shouldCancel
    End Sub

    Private Sub EditorControl_ViewCellFormatting(ByVal sender As Object, ByVal e As CellFormattingEventArgs)
        Dim filterCell As GridFilterCellElement = TryCast(e.CellElement, GridFilterCellElement)

        If filterCell IsNot Nothing Then
            filterCell.FilterButton.Visibility = Telerik.WinControls.ElementVisibility.Collapsed
        End If
    End Sub

End Class
